[![PyPi Package Version](https://img.shields.io/pypi/v/combidata.svg)](https://pypi.python.org/pypi/combidata)
[![Supported Python versions](https://img.shields.io/pypi/pyversions/combidata.svg)](https://pypi.python.org/pypi/combidata)
[![PyPi status](https://img.shields.io/pypi/status/combidata.svg?style=flat-square)](https://pypi.python.org/pypi/combidata)

# Combidata
<p align="center">
  <img src="docs/assets/logo.svg" alt="Combidata Logo" width="200" height="200"/>
</p>
Combidata is a case-oriented library designed for compositional testing of combinatorics in IT product functionalities.

## Installation


```
pip install combidata
```

## Table of Contents

- [Installation](https://warrfie.github.io/combidata/Installation)
- [All entities](https://warrfie.github.io/combidata/Cases)
  - [Process](https://warrfie.github.io/combidata/Process)
  - [Cases](https://warrfie.github.io/combidata/Cases)
  - [Combination](https://warrfie.github.io/combidata/Combination)
  - [DataGenerator](https://warrfie.github.io/combidata/DataGenerator)
- [Quick Start Guide](https://warrfie.github.io/combidata/QSG)

## Overview

Combidata provides a comprehensive solution for compositional testing, allowing users to efficiently test various combinations of functionalities in IT products. With its unique approach to case-oriented testing, Combidata streamlines the testing process, ensuring robust and reliable results.

## Features

- **Case-Oriented Testing**: Focus on specific test cases to ensure thorough testing of functionalities.
- **Compositional Testing**: Test combinations of functionalities to ensure interoperability and compatibility.
- **Efficient Workflow**: Streamlined processes for test generation, execution, and reporting.
- **Extensive Documentation**: Comprehensive guides and tutorials to help you get started and make the most of Combidata.

## Getting Started

To get started with Combidata, visit our [Quick Start Guide](https://warrfie.github.io/combidata/QSG) which provides step-by-step instructions on setting up and using the library.

## Support
If you need help with Combidata or have any questions, please open an issue on GitHub or contact the maintainers directly 

Telegram — https://t.me/sasisochka

Linkedin — https://www.linkedin.com/in/yasasisochka/

## License

Combidata is licensed under [MIT License](LICENSE).